#ifndef _TEST_APP
#define _TEST_APP


#include "ofMain.h"

#define OF_ADDON_USING_OFXOPENCV
#include "ofAddons.h"
#include <list>

class testApp : public ofSimpleApp{
	
	public:
		
		void setup();
		void update();
		void draw();
		
		void keyPressed(int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased();
		
    // methods:
        void doDetection(ofImage img);
        int countChange();
    
        void seedFill(int x, int y, int label);
        void testApp::makeTarget(int _x, int _y);
    
        void initTextures();

    // properties:
        ofImage displayImage;
        float displayRatio;
    
        vector<ofImage> coinImages;
        int selectedImage;
    
        ofTexture thresholdTexture;
        unsigned char * thresholdPixels;

        ofTexture objectTexture;
        unsigned char * objectPixels;

        int imgWidth;
        int imgHeight;

        int threshold;

        struct Object {
            int label;
            int xsum;
            int ysum;
            int count;
            int value;
        };

        int totalValue;
    
        vector<int> coinSizes;
        list<Object> objects;

        ofTrueTypeFont ttf_big;
        ofTrueTypeFont ttf_sm;
        ofTrueTypeFont ttf_tiny;
    
        bool displayThreshold;
        bool displayTargets;
};

#endif
	
